* Program to calculate two types of AIC and BIC tests
* Joseph M. Hilbe, hilbe(at)asu.edu
program define abic
	version 9.1
	quietly {
		local  ll   = e(ll)
		if `ll' == . {			/* In case deviance-based */
			local ll = -.5*e(dev)
		}
        else
	
        qui {

           tempvar  aicn aic bic abic
           tempname b
	   local nobs  = e(N)
	   matrix `b'  = e(b)
	   local  p    = colsof(`b') 
	   local  nc   = 0 	   
           local  k    = e(k)
           local npred = e(df_m)
        
           gen `aicn'  = (-2*`ll' + 2*`k')/`nobs'
           gen `aic'   = (-2*`ll' + 2*`k')
           gen `bic'   = -2*(`ll'-`k'*ln(`k'))/`nobs'
           gen `abic' = -2*`ll'+`k'*ln(`nobs')
        }
}

di as txt _col(1) "AIC Statistic   =  " as res %9.0g `aicn' _col(40) in gr "AIC*n      = " in ye `aic'
di as txt _col(1) "BIC Statistic   =  " as res %9.0g `bic'  _col(40) in gr "BIC(Stata) = " in ye `abic'

end

