*! version 1.0.0  23jun2011
program define pigreg_lf
    version 6.0
	args todo b lnf g H sc1 sc2

/* Calculate the log-likelihood. */

	tempvar  xb 
	tempname lnalpha
	
	mleval   `xb' = `b'     , eq(1)
	mleval   `lnalpha' = `b', eq(2) scalar
	
	local y "$ML_y1"
	
	if `lnalpha' < -20 {
		mlsum `lnf' = -lngamma(`y'+1) - exp(`xb') + `y'*`xb'
		exit
 	}
	quietly {
		tempvar  mu p0 pj pjm1 pjm2 ty ti tip1
		tempname m
		
		scalar `m' = exp(`lnalpha')
		gen double `mu' = exp(`xb')                                                               if $ML_samp
		gen double `p0' = exp((1/`m')* (1-sqrt(1+2*`m'*`mu')))                                    if $ML_samp
		gen double `pjm2' = `mu'/sqrt(1+2*`m'*`mu')*`p0'                                          if $ML_samp
		gen double `pjm1' = 2*`m'*`mu'/(1+2*`m'*`mu')*.25*`pjm2' + `mu'^2/(1+2*`m'*`mu')*.50*`p0' if $ML_samp
		
		gen double `ty' = -lngamma(`y'+1) + ln(`p0')      if $ML_samp
		replace `ty' = `ty' + log((0+1)*`pjm2'/`p0')      if `y' > 0 & $ML_samp   /* t(0) */
		replace `ty' = `ty' + log((1+1)*`pjm1'/`pjm2')    if `y' > 1 & $ML_samp   /* t(1) */
		
		gen double `ti' = .
		replace `ti' = 1*`pjm2'/`p0'   if `y'==0 & $ML_samp
		replace `ti' = 2*`pjm1'/`pjm2' if `y'==1 & $ML_samp
		
		gen double `tip1' = .
		replace `tip1' = 2*`pjm1'/`pjm2' if `y'==0 & $ML_samp
		
		summ `y' if $ML_samp
		local my = r(max)-1
		drop `p0'
		gen double `pj'   = .    if $ML_samp
		
		forvalues i=2/`my' {                                                       
			replace `pj'   = 2*`m'*`mu'/(1+2*`m'*`mu')*(1-3/(2*(`i'+1)))*`pjm1' + /*
				*/ `mu'^2/(1+2*`m'*`mu')*(1/(`i'*(`i'+1)))*`pjm2'                    if $ML_samp
	
			replace `tip1' = (`i'+1)*`pj'/`pjm1'                          if `y'==(`i'-1) & $ML_samp
			replace `ti'   = (`i'+1)*`pj'/`pjm1'                          if `y'==`i'     & $ML_samp
			replace `ty'   = `ty' + log((`i'+1)*`pj'/`pjm1')              if `y' > `i'    & $ML_samp
			
			replace `pjm2' = `pjm1'                                                      if $ML_samp
			replace `pjm1' = `pj'                                                        if $ML_samp
		}
		local i = `my'+1
		replace `pj'   = 2*`m'*`mu'/(1+2*`m'*`mu')*(1-3/(2*(`i'+1)))*`pjm1' + /*
			*/ `mu'^2/(1+2*`m'*`mu')*(1/(`i'*(`i'+1)))*`pjm2'                            if $ML_samp
		replace `tip1' = (`i'+1)*`pj'/`pjm1'                              if `y'==(`i'-1) & $ML_samp
		replace `ti'   = (`i'+1)*`pj'/`pjm1'                                 if `y'==`i'  & $ML_samp
		replace `pjm2' = `pjm1'                                                          if $ML_samp
		replace `pjm1' = `pj'                                                            if $ML_samp
		
		local i = `i'+1
		replace `pj'   = 2*`m'*`mu'/(1+2*`m'*`mu')*(1-3/(2*(`i'+1)))*`pjm1' + /*
			*/ `mu'^2/(1+2*`m'*`mu')*(1/(`i'*(`i'+1)))*`pjm2'                            if $ML_samp
		replace `tip1' = (`i'+1)*`pj'/`pjm1'                              if `y'==(`i'-1) & $ML_samp

		mlsum `lnf' = `ty'
		
		if `todo' == 0 | `lnf'==. { exit }

			
		
		/* Calculate the scores and gradient. */
		quietly {
			replace `sc1' = (`y'-`ti')/`mu'                               if $ML_samp
			replace `sc2' = ((1+`m'*`mu')/`mu'*`ti' -(1+`m'*`y'))/(`m'^2) if $ML_samp
		}

		tempname g1 g2
		mlvecsum `lnf' `g1' = `sc1'*`mu', eq(1)
		mlvecsum `lnf' `g2' = `sc2'*`m', eq(2)
		matrix `g' = (`g1',`g2')

		if `todo' == 1 | `lnf'==. { exit }
		
		/* Calculate negative hessian. */
		tempname d11 d12 d22

		mlmatsum `lnf' `d11' = (`y'-`ti'*`tip1'+`ti'*`ti')+ (`ti'-`y'), eq(1)

		mlmatsum `lnf' `d12' = ((`tip1'-`ti')*(1+`m'*`mu')/(`m'*`mu')-1)*`ti', eq(1,2)

		mlmatsum `lnf' `d22' = (`ti'*(3+2*`m'*`mu')/(`m'^3*`mu')-(2+`m'*`y')/(`m'^3) - /*
			*/ (1+`m'*`mu')^2/(`m'^4*`mu'^2)*`ti'*(`tip1'-`ti'))*`m'*`m' - `sc2'*`m', eq(2)
		
		matrix `H' = (`d11',`d12' \ `d12'',`d22')
	}
end
