* Poisson Chapter
drop _all

clear
input LOS count
1  9
2  10
3  11
4  12
5  13
6  12
7  11
8  10
9  9
10  8
11  7
12  6
13  5
14  4
15  3
16  2
17  1
end
capture program drop doit
program doit
	version 6.0
	graph count LOS, xlab(1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17) /*
		*/ ylab(0,1,2,3,4,5,6,7,8,9,10,11,12,13) c(.) s(o) saving(poisson, replace)
end
doit
graph export poisson.eps, replace


use medpar, clear
glm los hmo white type2 type3, family(poisson) eform nolog

glm los hmo white type2 type3, family(poisson) irls scale(x2) eform noheader nolog

glm los hmo white type2 type3, family(poisson) cluster(provnum) eform noheader nolog

use doll
glm deaths smokes a2-a5, family(poisson) exposure(pyears) eform nolog

glm deaths smokes a2-a5, family(poisson) irls scale(x2) exposure(pyears) eform noheader nolog

generate sa12 = smokes*(a1+a2)
generate sa34 = smokes*(a3+a4)
generate sa5  = smokes*(a5)
glm deaths sa12 sa34 sa5 a2-a5, family(poisson) irls scale(x2) lnoffset(pyears) eform noheader nolog

use medpar, clear
glm los hmo white type2 type3, family(poisson) eform noheader nolog
predict double mu, mu
generate z = ((los-mu)^2-los)/(mu*sqrt(2))
regress z

quietly summarize los if e(sample), meanonly
quietly scalar nybar = r(sum)
quietly generate double musq = mu*mu
quietly summarize musq if e(sample), meanonly
quietly scalar mu2 = r(sum)
quietly scalar chival = (mu2-nybar)^2/(2*mu2)
display as txt "LM value = " as res chival _n as txt "P-value  = " as res %6.4f chi2tail(1, chival)

sysuse cancer, clear
glm died age i.drug, exposure(studytime) family(poisson) nolog
stset studytime, failure(died)
streg age i.drug, nohr dist(exp) nolog

glm died age i.drug, exposure(studytime) family(poisson) noheader nolog

test age=0, notest
test 2.drug=-1.5, accumulate

estimates store Unconstrained

generate double offvar = 0*age - 1.5*2.drug + log(studytime)

glm died 3.drug, offset(offvar) family(poisson) nolog 
lrtest Unconstrained

constraint 1 age=0
constraint 2 2.drug=-1.5
glm died age i.drug, exposure(studytime) family(poisson) constraints(1 2) nolog
lrtest Unconstrained

use medpar, clear
glm los hmo white type2 type3, family(poisson) noheader nolog

