* Unordered Outcome Chapter
drop _all
clear


use heart
mlogit death anterior hcabg kk2 kk3 age2-age4, nolog

glm death anterior hcabg kk2 kk3 age2-age4, family(binomial) noheader nolog

use tbl19-2, clear
generate cc = mod(_n-1,4)+1
generate g  = int((_n-1)/4)+1
generate air    = cc==1
generate bus    = cc==3
generate train  = cc==2
generate airinc = air*hinc
generate choice  = cc*mode
generate hair    = hinc*air
generate htrain  = hinc*train
generate hbus    = hinc*bus
generate psair   = psize*air
generate pstrain = psize*train
generate psbus   = psize*bus
label define mlab 1 "air" 2 "train" 3 "bus" 4 "car"
label values choice mlab 

clogit mode hair psair air htrain pstrain train hbus psbus bus, group(g) nolog
mlogit choice hinc psize if choice>0, base(4) nolog

clogit mode air bus train gc ttme airinc, group(g) nolog

mlogit choice hinc psize if choice>0, base(4) nolog
estimates store all
mlogit choice hinc psize if choice!=0 & choice!=2, base(4) nolog
estimates store partial
hausman partial all, alleqs constant

use medpar, clear
generate byte admit = type1 + 2*type2 + 3*type3
label define admitlab 1 "Elective" 2 "Urgent" 3 "Emergency"
label values admit admitlab
label define whitelab 1 "White" 0 "Other"
label values white whitelab
tabulate admit

tabulate admit white

mlogit admit white, rrr nolog

mlogit admit white, base(2) nolog

by admit, sort: summarize white los

mlogit admit white los, nolog
abic

mlogit admit white los, rrr nolog
predict p1 p2 p3

sort white los
line p1 los if white==0 || line p1 los if white==1, legend(order(1 "nonwhite" 2 "white")) title(Medicare LOS vs Admission Type) l1title("Admit=1: Elective Admission") clpattern("-###")
graph export medpar1.eps, replace

line p2 los if white==0 || line p2 los if white==1, legend(order(1 "nonwhite" 2 "white")) title(Medicare LOS vs Admission Type) l1title("Admit=2: Urgent Admission") clpattern("-###")
graph export medpar2.eps, replace

line p3 los if white==0 || line p3 los if white==1, legend(order(1 "nonwhite" 2 "white")) title(Medicare LOS vs Admission Type) l1title("Admit=3: Emergency Admission") clpattern("-###")
graph export medpar3.eps, replace

quietly mlogit admit white los
estimates store mlogit
quietly ologit admit white los
lrtest mlogit, force

mlogit admit white los, nolog
abic
predict pl1 pl2 pl3

mprobit admit white los, nolog
abic
predict pp1 pp2 pp3

list pp1 pl1 pp2 pl2 pp3 pl3 in 1/10

correlate pp1 pl1
correlate pp2 pl2
correlate pp3 pl3

tabulate admit, nolabel
generate byte admitbin = (admit==1)  /* Create a binary variable */
tabulate admitbin

probit admitbin white los, nolog
predict prob1

mprobit admitbin white los, baseoutcome(0) nolog

matrix probitcoef = e(b)/sqrt(2)
matrix list probitcoef

mprobit admitbin white los, probitparam baseoutcome(0) nolog
predict mprob1 mprob2

correlate prob1 mprob1 mprob2

list prob1 mprob1 mprob2 in 1/10

quietly mprobit admitbin white los, baseoutcome(0) nolog
predict pm1 pm2
correlate prob1 mprob1 mprob2 pm1 pm2
list prob1 mprob1 mprob2 pm1 pm2 in 1/5
