{smcl}
{* *! version 1.1.3  14jun2009}{...}
{cmd:help zigp postestimation} {right:dialog:  {dialog zip_p:predict}}
{right:also see:  {help zigp}{space 3}}
{hline}

{title:Title}

{p2colset 5 32 34 2}{...}
{p2col :{manlink R zigp postestimation} {hline 2}}Postestimation tools for zigp
{p_end}
{p2colreset}{...}


{title:Description}

{pstd}
The following postestimation commands are available for {cmd:zigp}:

{synoptset 13 notes}{...}
{p2coldent :command}description{p_end}
{synoptline}
INCLUDE help post_estat
INCLUDE help post_svy_estat
INCLUDE help post_estimates
INCLUDE help post_lincom
INCLUDE help post_lrtest_star
INCLUDE help post_margins
INCLUDE help post_nlcom
{synopt :{helpb zigp postestimation##predict:predict}}predictions, residuals,
influence statistics, and other diagnostic measures{p_end}
INCLUDE help post_predictnl
INCLUDE help post_suest
INCLUDE help post_test
INCLUDE help post_testnl
{synoptline}
{p2colreset}{...}
INCLUDE help post_lrtest_star_msg


{marker predict}{...}
{title:Syntax for predict}

{p 8 18 2}
{cmd:predict} {dtype} {newvar} {ifin} 
[{cmd:,} {it:{help zigp postestimation##statistic:statistic}} {opt nooff:set}]

{p 8 18 2}
{cmd:predict} {dtype} {{it:stub}{cmd:*}|{it:newvar_reg} {it:newvar_inflate} 
{it:newvar_lnalpha}} {ifin}{cmd:,} {opt sc:ores}

{marker statistic}{...}
{synoptset 11 tabbed}{...}
{synopthdr:statistic}
{synoptline}
{syntab:Main}
{synopt :{opt n}}number of events; the default{p_end}
{synopt :{opt ir}}incidence rate{p_end}
{synopt :{opt p:r}}probability a zero outcome{p_end}
{synopt :{opt xb}}linear prediction{p_end}
{synopt :{opt stdp}}standard error of the linear prediction{p_end}
{synoptline}
{p2colreset}{...}
INCLUDE help esample


INCLUDE help menu_predict


{title:Options for predict}

{dlgtab:Main}

{phang}
{opt n}, the default, calculates the predicted number of events, which is 
(1-p_j)exp(x_j b) if neither {opt offset()} nor {opt exposure()} was specified
when the model was fit, where p_j is the predicted probability of a zero
outcome; (1-p_j)exp((x_j b) + offset_j) if {opt offset()} was specified; or
{bind:(1-p_j)(exp(x_j b) * exposure_j}) if {opt exposure()} was specified.

{phang}
{opt ir} calculates the incidence rate exp(xb), which is the predicted
number of events when exposure is 1.  This is equivalent to specifying both
{opt n} and {opt offset} options.

{phang}
{opt pr} calculates the probability of a zero outcome F(zg), where F() is
the logit or probit link function.  If {opt offset()} was specified within the 
{opt inflate()} option, then F(zg + offset^g) is calculated.

{phang}
{opt xb} calculates the linear prediction, which is xb if neither 
{opt offset()} nor {opt exposure()} was specified; {bind:xb + offset} if 
{opt offset()} was specified; or {bind:xb + ln(exposure)} if 
{opt exposure()} was specified; see {opt nooffset} below.

{phang}
{opt stdp} calculates the standard error of the linear prediction.

{phang}
{opt nooffset} is relevant only if you specified {opt offset()} or
{opt exposure()} when you fit the model.  It modifies the calculations made
by {opt predict} so that they ignore the offset or exposure variable; the
linear prediction is treated as xb rather than as 
{bind:xb + offset} or {bind:xb + ln(exposure)}.  Specifying
{bind:{cmd:predict ..., nooffset}} is equivalent to specifying 
{bind:{cmd:predict ..., ir}}.

{phang}
{opt scores} calculates equation-level score variables.

{pmore}
The first new variable will contain the derivative of the log likelihood with
respect to the regression equation.

{pmore}
The second new variable will contain the derivative of the log likelihood with
respect to the inflation equation.

{pmore}
The third new variable will contain the derivative of the log likelihood with
respect to the dispersion equation ({hi:lnalpha}).


{title:Examples}

{pstd}Setup{p_end}
{phang2}{cmd:. webuse fish}{p_end}
{phang2}{cmd:. zigp count persons i.livebait, inflate(child camper)}{p_end}

{pstd}Number of events{p_end}
{phang2}{cmd:. predict n}

{pstd}Linear prediction{p_end}
{phang2}{cmd:. predict lp, xb}

{pstd}Predictive margins for {cmd:livebait}{p_end}
{phang2}{cmd:. margins livebait}


{title:Also see}

{psee}
Manual:  {manlink R zigp postestimation}{p_end}

{psee}
{space 2}Help:  {manhelp zigp R}
{p_end}
